import c4d
# Reset PR to Workplane

# Authot Mike Udin,2016, http://mikeudin.net   
# Reset position and rotation 
# of selected objects to zero point of the Workplane

# How to use:
# Select objects and run the script. 
# Press Shift to reset position only 
 
def main():
    objs = doc.GetActiveObjects(1)
    if not objs:
        return
    
    bc = c4d.BaseContainer()
    if c4d.gui.GetInputState(c4d.BFM_INPUT_KEYBOARD,c4d.BFM_INPUT_CHANNEL,bc):
        input_id = bc[c4d.BFM_INPUT_QUALIFIER]
    
    doc.StartUndo()
    for obj in objs:
        m_obj_orig = obj.GetMg()
        wp = c4d.modules.snap.GetWorkplaneObject(doc)
        doc.AddUndo(c4d.UNDOTYPE_CHANGE, obj)
        if input_id == 1:
            obj.SetRelPos(wp.GetRelPos())
        else:
            obj.SetRelPos(wp.GetRelPos())
            obj.SetRelRot(wp.GetRelRot())
            #obj.SetMg(wp.GetMg())
    obj.Message(c4d.MSG_UPDATE)
    c4d.EventAdd()  
    
    doc.EndUndo()     
 
if __name__=='__main__':
    main()